Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_interp.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_interp.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_interp.F90	(revision 13229)
@@ -593,38 +625,46 @@
       !
       ! --- West --- !
-      istart = nn_hls + 2                              ! halo + land + 1
-      iend   = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-      DO ji = mi0(istart), mi1(iend)
-         DO jj = 1, jpj
-            ssha_e(ji,jj) = hbdy(ji,jj)
+      IF( lk_west ) THEN
+         istart = nn_hls + 2                              ! halo + land + 1
+         iend   = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+         DO ji = mi0(istart), mi1(iend)
+            DO jj = 1, jpj
+               ssha_e(ji,jj) = hbdy(ji,jj)
+            ENDDO
          ENDDO
-      ENDDO
+      ENDIF
       !
       ! --- East --- !
-      istart = jpiglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
-      iend   = jpiglo - ( nn_hls + 1 )                 ! halo + land + 1            - 1
-      DO ji = mi0(istart), mi1(iend)
-         DO jj = 1, jpj
-            ssha_e(ji,jj) = hbdy(ji,jj)
+      IF( lk_east ) THEN
+         istart = jpiglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
+         iend   = jpiglo - ( nn_hls + 1 )                 ! halo + land + 1            - 1
+         DO ji = mi0(istart), mi1(iend)
+            DO jj = 1, jpj
+               ssha_e(ji,jj) = hbdy(ji,jj)
+            ENDDO
          ENDDO
-      ENDDO
+      ENDIF
       !
       ! --- South --- !
-      jstart = nn_hls + 2                              ! halo + land + 1
-      jend   = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-      DO jj = mj0(jstart), mj1(jend)
-         DO ji = 1, jpi
-            ssha_e(ji,jj) = hbdy(ji,jj)
+      IF( lk_south ) THEN
+         jstart = nn_hls + 2                              ! halo + land + 1
+         jend   = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+         DO jj = mj0(jstart), mj1(jend)
+            DO ji = 1, jpi
+               ssha_e(ji,jj) = hbdy(ji,jj)
+            ENDDO
          ENDDO
-      ENDDO
+      ENDIF
       !
       ! --- North --- !
-      jstart = jpjglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
-      jend   = jpjglo - ( nn_hls + 1 )                 ! halo + land + 1            - 1
-      DO jj = mj0(jstart), mj1(jend)
-         DO ji = 1, jpi
-            ssha_e(ji,jj) = hbdy(ji,jj)
+      IF( lk_north ) THEN
+         jstart = jpjglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
+         jend   = jpjglo - ( nn_hls + 1 )                 ! halo + land + 1            - 1
+         DO jj = mj0(jstart), mj1(jend)
+            DO ji = 1, jpi
+               ssha_e(ji,jj) = hbdy(ji,jj)
+            ENDDO
          ENDDO
-      ENDDO
+      ENDIF
       !
    END SUBROUTINE Agrif_ssh_ts
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_sponge.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_sponge.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_sponge.F90	(revision 13229)
@@ -131,42 +131,50 @@
 
          ! --- West --- !
-         ztabramp(:,:) = 0._wp
-         ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-         DO ji = mi0(ind1), mi1(ind1)                
-            ztabramp(ji,:) = ssumask(ji,:)
-         END DO
-         !
-         zmskwest(1:jpj) = MAXVAL(ztabramp(:,:), dim=1)
-         zmskwest(jpj+1:jpjmax) = 0._wp
+         IF( lk_west ) THEN
+            ztabramp(:,:) = 0._wp
+            ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+            DO ji = mi0(ind1), mi1(ind1)                
+               ztabramp(ji,:) = ssumask(ji,:)
+            END DO
+            !
+            zmskwest(1:jpj) = MAXVAL(ztabramp(:,:), dim=1)
+            zmskwest(jpj+1:jpjmax) = 0._wp
+         ENDIF
 
          ! --- East --- !
-         ztabramp(:,:) = 0._wp
-         ind1 = jpiglo - ( nn_hls + nbghostcells + 1)   ! halo + land + nbghostcells
-         DO ji = mi0(ind1), mi1(ind1)                 
-            ztabramp(ji,:) = ssumask(ji,:)
-         END DO
-         !
-         zmskeast(1:jpj) = MAXVAL(ztabramp(:,:), dim=1)
-         zmskeast(jpj+1:jpjmax) = 0._wp
+         IF( lk_east ) THEN
+            ztabramp(:,:) = 0._wp
+            ind1 = jpiglo - ( nn_hls + nbghostcells + 1)   ! halo + land + nbghostcells
+            DO ji = mi0(ind1), mi1(ind1)                 
+               ztabramp(ji,:) = ssumask(ji,:)
+            END DO
+            !
+            zmskeast(1:jpj) = MAXVAL(ztabramp(:,:), dim=1)
+            zmskeast(jpj+1:jpjmax) = 0._wp
+         ENDIF
 
          ! --- South --- !
-         ztabramp(:,:) = 0._wp
-         ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-         DO jj = mj0(ind1), mj1(ind1)                 
-            ztabramp(:,jj) = ssvmask(:,jj)
-         END DO
-         !
-         zmsksouth(1:jpi) = MAXVAL(ztabramp(:,:), dim=2)
-         zmsksouth(jpi+1:jpimax) = 0._wp
+         IF( lk_south ) THEN
+            ztabramp(:,:) = 0._wp
+            ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+            DO jj = mj0(ind1), mj1(ind1)                 
+               ztabramp(:,jj) = ssvmask(:,jj)
+            END DO
+            !
+            zmsksouth(1:jpi) = MAXVAL(ztabramp(:,:), dim=2)
+            zmsksouth(jpi+1:jpimax) = 0._wp
+         ENDIF
 
          ! --- North --- !
-         ztabramp(:,:) = 0._wp
-         ind1 = jpjglo - ( nn_hls + nbghostcells + 1)   ! halo + land + nbghostcells
-         DO jj = mj0(ind1), mj1(ind1)                 
-            ztabramp(:,jj) = ssvmask(:,jj)
-         END DO
-         !
-         zmsknorth(1:jpi) = MAXVAL(ztabramp(:,:), dim=2)
-         zmsknorth(jpi+1:jpimax) = 0._wp
+         IF( lk_north ) THEN
+            ztabramp(:,:) = 0._wp
+            ind1 = jpjglo - ( nn_hls + nbghostcells + 1)   ! halo + land + nbghostcells
+            DO jj = mj0(ind1), mj1(ind1)                 
+               ztabramp(:,jj) = ssvmask(:,jj)
+            END DO
+            !
+            zmsknorth(1:jpi) = MAXVAL(ztabramp(:,:), dim=2)
+            zmsknorth(jpi+1:jpimax) = 0._wp
+         ENDIF
 
          ! JC: SPONGE MASKING TO BE SORTED OUT:
@@ -197,74 +205,82 @@
 
          ! --- West --- !
-         ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-         ind2 = nn_hls + 1 + nbghostcells + ispongearea 
-         DO ji = mi0(ind1), mi1(ind2)   
-            DO jj = 1, jpj               
-               ztabramp(ji,jj) = REAL( ind2 - mig(ji) ) * z1_ispongearea * zmskwest(jj)
-            END DO
-         END DO
-
-         ! ghost cells:
-         ind1 = 1
-         ind2 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-         DO ji = mi0(ind1), mi1(ind2)   
-            DO jj = 1, jpj               
-               ztabramp(ji,jj) = zmskwest(jj)
-            END DO
-         END DO
+         IF( lk_west ) THEN
+            ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+            ind2 = nn_hls + 1 + nbghostcells + ispongearea 
+            DO ji = mi0(ind1), mi1(ind2)   
+               DO jj = 1, jpj               
+                  ztabramp(ji,jj) = REAL( ind2 - mig(ji) ) * z1_ispongearea * zmskwest(jj)
+               END DO
+            END DO
+
+            ! ghost cells:
+            ind1 = 1
+            ind2 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+            DO ji = mi0(ind1), mi1(ind2)   
+               DO jj = 1, jpj               
+                  ztabramp(ji,jj) = zmskwest(jj)
+               END DO
+            END DO
+         ENDIF
 
          ! --- East --- !
-         ind1 = jpiglo - ( nn_hls + nbghostcells ) - ispongearea
-         ind2 = jpiglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
-         DO ji = mi0(ind1), mi1(ind2)
-            DO jj = 1, jpj
-               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( mig(ji) - ind1 ) * z1_ispongearea) * zmskeast(jj)
-            ENDDO
-         END DO
-
-         ! ghost cells:
-         ind1 = jpiglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
-         ind2 = jpiglo
-         DO ji = mi0(ind1), mi1(ind2)
-            DO jj = 1, jpj
-               ztabramp(ji,jj) = zmskeast(jj)
-            ENDDO
-         END DO
+         IF( lk_east ) THEN
+            ind1 = jpiglo - ( nn_hls + nbghostcells ) - ispongearea
+            ind2 = jpiglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
+            DO ji = mi0(ind1), mi1(ind2)
+               DO jj = 1, jpj
+                  ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( mig(ji) - ind1 ) * z1_ispongearea) * zmskeast(jj)
+               ENDDO
+            END DO
+
+            ! ghost cells:
+            ind1 = jpiglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
+            ind2 = jpiglo
+            DO ji = mi0(ind1), mi1(ind2)
+               DO jj = 1, jpj
+                  ztabramp(ji,jj) = zmskeast(jj)
+               ENDDO
+            END DO
+         ENDIF
 
          ! --- South --- !
-         ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-         ind2 = nn_hls + 1 + nbghostcells + jspongearea 
-         DO jj = mj0(ind1), mj1(ind2) 
-            DO ji = 1, jpi
-               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( ind2 - mjg(jj) ) * z1_jspongearea) * zmsksouth(ji)
-            END DO
-         END DO
-
-         ! ghost cells:
-         ind1 = 1
-         ind2 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
-         DO jj = mj0(ind1), mj1(ind2) 
-            DO ji = 1, jpi
-               ztabramp(ji,jj) = zmsksouth(ji)
-            END DO
-         END DO
+         IF( lk_south ) THEN
+            ind1 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+            ind2 = nn_hls + 1 + nbghostcells + jspongearea 
+            DO jj = mj0(ind1), mj1(ind2) 
+               DO ji = 1, jpi
+                  ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( ind2 - mjg(jj) ) * z1_jspongearea) * zmsksouth(ji)
+               END DO
+            END DO
+
+            ! ghost cells:
+            ind1 = 1
+            ind2 = nn_hls + 1 + nbghostcells               ! halo + land + nbghostcells
+            DO jj = mj0(ind1), mj1(ind2) 
+               DO ji = 1, jpi
+                  ztabramp(ji,jj) = zmsksouth(ji)
+               END DO
+            END DO
+         ENDIF
 
          ! --- North --- !
-         ind1 = jpjglo - ( nn_hls + nbghostcells ) - jspongearea
-         ind2 = jpjglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
-         DO jj = mj0(ind1), mj1(ind2)
-            DO ji = 1, jpi
-               ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( mjg(jj) - ind1 ) * z1_jspongearea) * zmsknorth(ji)
-            END DO
-         END DO
-
-         ! ghost cells:
-         ind1 = jpjglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
-         ind2 = jpjglo
-         DO jj = mj0(ind1), mj1(ind2)
-            DO ji = 1, jpi
-               ztabramp(ji,jj) = zmsknorth(ji)
-            END DO
-         END DO
+         IF( lk_north ) THEN
+            ind1 = jpjglo - ( nn_hls + nbghostcells ) - jspongearea
+            ind2 = jpjglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
+            DO jj = mj0(ind1), mj1(ind2)
+               DO ji = 1, jpi
+                  ztabramp(ji,jj) = MAX( ztabramp(ji,jj), REAL( mjg(jj) - ind1 ) * z1_jspongearea) * zmsknorth(ji)
+               END DO
+            END DO
+
+            ! ghost cells:
+            ind1 = jpjglo - ( nn_hls + nbghostcells )      ! halo + land + nbghostcells - 1
+            ind2 = jpjglo
+            DO jj = mj0(ind1), mj1(ind2)
+               DO ji = 1, jpi
+                  ztabramp(ji,jj) = zmsknorth(ji)
+               END DO
+            END DO
+         ENDIF
 
       ENDIF
Index: NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_update.F90
===================================================================
--- NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_update.F90	(revision 13228)
+++ NEMO/branches/2020/dev_r12558_HPC-08_epico_Extra_Halo/src/NST/agrif_oce_update.F90	(revision 13229)
@@ -26,4 +26,5 @@
    USE domvvl         ! Need interpolation routines 
    USE vremap         ! Vertical remapping
+   USE lbclnk 
 
    IMPLICIT NONE
@@ -85,4 +86,8 @@
       Agrif_UseSpecialValueInUpdate = .FALSE.
       Agrif_SpecialValueFineGrid = 0.
+
+      use_sign_north = .TRUE.
+      sign_north = -1.
+
       !     
 # if ! defined DECAL_FEEDBACK
@@ -127,4 +132,6 @@
       END IF
       !
+      use_sign_north = .FALSE.
+      !
    END SUBROUTINE Agrif_Update_Dyn
 
@@ -148,4 +155,6 @@
 #  if defined VOL_REFLUX
       IF ( ln_dynspg_ts.AND.ln_bt_fw ) THEN
+         use_sign_north = .TRUE.
+         sign_north = -1.
          ! Refluxing on ssh:
 #  if defined DECAL_FEEDBACK_2D
@@ -156,4 +165,5 @@
          CALL Agrif_Update_Variable(vb2b_update_id,locupdate1=(/ 0, 0/),locupdate2=(/-1,-1/),procname = reflux_sshv)
 #  endif
+         use_sign_north = .FALSE.
       END IF
 #  endif
@@ -826,5 +836,5 @@
    SUBROUTINE correct_v_bdy( tabres, i1, i2, j1, j2, k1, k2, n1, n2, before, nb, ndir )
       !!---------------------------------------------
-      !!           *** ROUTINE correct_u_bdy ***
+      !!           *** ROUTINE correct_v_bdy ***
       !!---------------------------------------------
       INTEGER                                     , INTENT(in   ) :: i1, i2, j1, j2, k1, k2, n1, n2
